#include "curses_input.h"

#include "../constants.h"

curses_input::curses_input(cursor *new_curse):
        curse{new_curse} {}

game_command curses_input::get_command() {
        int tmp;

        switch (curse->getcmd()) {
        case 'h':
                return game_command::move_west;

        case 'j':
                return game_command::move_south;

        case 'k':
                return game_command::move_north;

        case 'l':
                return game_command::move_east;

        case 'y':
                return game_command::move_northwest;

        case 'u':
                return game_command::move_northeast;

        case 'b':
                return game_command::move_southwest;

        case 'n':
                return game_command::move_southeast;

        case 'a':
                tmp = apply_north;
                break; // wait for another command

        case '<':
                return game_command::up_stairs;

        case '>':
                return game_command::down_stairs;

        case 'q':
                return game_command_terminate;

        case 'f':
                return game_command::the_world;

        case 'r':
                return game_restart;

        case 'e':
                return game_command::enter;

        case 'i':
                return toggle_inventory;

        case 't':
                tmp = throw_north;
                break;

        default:
                return game_command_pass;
        }

        switch (curse->getcmd()) {
        case 'h':
                return (game_command)(tmp + west);

        case 'j':
                return (game_command)(tmp + south);

        case 'k':
                return (game_command)(tmp + north);

        case 'l':
                return (game_command)(tmp + east);

        case 'y':
                return (game_command)(tmp + northwest);

        case 'u':
                return (game_command)(tmp + northeast);

        case 'b':
                return (game_command)(tmp + southwest);

        case 'n':
                return (game_command)(tmp + southeast);

        default:
                return game_command_panic;
        }

        return game_command::game_command_panic;
}
